package me.Demon.DemonAntiEvent.Listener;

import me.Demon.DemonAntiEvent.Main;
import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonPlugin.Util.ItemNameUtil;
import org.bukkit.Sound;
import org.bukkit.enchantments.Enchantment;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.inventory.ItemFlag;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.List;

public class AntiEnchant implements Listener {

    public static String getItemName(ItemStack item) {
        ItemStack items = item.clone();
        return ItemNameUtil.getChineseName(items);
    }

    @EventHandler
    public void onPlayerUse(PlayerInteractEvent e) {
        Player p = e.getPlayer();
        ItemStack item = p.getItemInHand();
        if (!DemonAPI.itemIsNull(item) && DemonAPI.itemIsName(item)) {
            String name = item.getType().name();
            boolean butt = false;
            if (name.contains("_AXE")) {
                butt = true;
            } else if (name.contains("_SPADE")) {
                butt = true;
            } else if (name.contains("_PICKAXE")) {
                butt = true;
            }
            if (butt) {
                if (item.getEnchantments().size() >= 1) {
                    ItemMeta meta = item.getItemMeta();
                    if (!meta.spigot().isUnbreakable()) {
                        item.setDurability((short) 0);
                        meta.spigot().setUnbreakable(true);
                    }
                    String itemName = getItemName(item);
                    meta.setDisplayName("§7[§f普通§7]§r" + itemName);
                    List<String> lore = new ArrayList<>();
                    lore.add("§7§0§1§r§7§7耐久§0§1§r§7§f§l: §0§2§r§a" + 512 + "§7/§a" + 512);
                    meta.setLore(lore);
                    meta.addItemFlags(ItemFlag.HIDE_UNBREAKABLE);
                    meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
                    item.setItemMeta(meta);
                    for (Enchantment enchant : item.getEnchantments().keySet()) {
                        if (enchant.getId() == 34) {
                            item.removeEnchantment(enchant);
                        }
                    }
                    p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 0.5F, 1.5F);
                    p.sendMessage("§7[§6战争领域§7] §f您的工具已完成RPG属性升级.");
                }
            }
        }
    }

    @EventHandler
    public void onUnbreakable(PlayerInteractEvent e) {
        Player p = e.getPlayer();
        ItemStack item = p.getItemInHand();
        if (!DemonAPI.itemIsNull(item) && !DemonAPI.itemIsLore(item)) {
            ItemMeta meta = item.getItemMeta();
            if (meta.getDisplayName().contains(":")) {
                String itemName = getItemName(item);
                meta.setDisplayName("§7[§f普通§7]§r" + itemName);
                if (!meta.spigot().isUnbreakable()) {
                    item.setDurability((short) 0);
                    meta.spigot().setUnbreakable(true);
                }
                meta.addItemFlags(ItemFlag.HIDE_UNBREAKABLE);
                item.setItemMeta(meta);
                for (Enchantment enchant : item.getEnchantments().keySet()) {
                    if (enchant.getId() == 34) {
                        item.removeEnchantment(enchant);
                    }
                }
                p.playSound(p.getLocation(), Sound.ENTITY_EXPERIENCE_ORB_PICKUP, 0.5F, 1.5F);
                p.sendMessage("§7[§6战争领域§7] §f您的工具已完成RPG属性升级.");
            }
        }
    }
}
